/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.23 Revision 1.370
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.23 2003/03/01 03:38:40 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.370 2011/12/02 10:22:41 ferringb Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15newdepend "!bootstrap? ( sys-devel/patch )" 18inherit multilib portability user
16 19
17DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
18 21
19# This function generate linker scripts in /usr/lib for dynamic 22if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 23
39 # Just make sure it exists 24# @FUNCTION: epause
40 dodir /usr/lib 25# @USAGE: [seconds]
41 26# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 28# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 30# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 31epause() {
47 otherwise we run into linking problems. 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 33}
57 34
58# Simple function to draw a line consisting of '=' the same length as $* 35# @FUNCTION: ebeep
59# 36# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 37# @DESCRIPTION:
61# 38# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
42ebeep() {
63 local i=0 43 local n
64 local str_length="" 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 46 echo -ne "\a"
79 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 48 echo -ne "\a"
49 sleep 1
81 done 50 done
51 fi
52}
82 53
83 echo 54else
84 55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 :
76 }
77fi
78
79# @FUNCTION: ecvs_clean
80# @USAGE: [list of dirs]
81# @DESCRIPTION:
82# Remove CVS directories recursiveley. Useful when a source tarball contains
83# internal CVS directories. Defaults to $PWD.
84ecvs_clean() {
85 [[ -z $* ]] && set -- .
86 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
87 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
88}
89
90# @FUNCTION: esvn_clean
91# @USAGE: [list of dirs]
92# @DESCRIPTION:
93# Remove .svn directories recursiveley. Useful when a source tarball contains
94# internal Subversion directories. Defaults to $PWD.
95esvn_clean() {
96 [[ -z $* ]] && set -- .
97 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
98}
99
100# @FUNCTION: eshopts_push
101# @USAGE: [options to `set` or `shopt`]
102# @DESCRIPTION:
103# Often times code will want to enable a shell option to change code behavior.
104# Since changing shell options can easily break other pieces of code (which
105# assume the default state), eshopts_push is used to (1) push the current shell
106# options onto a stack and (2) pass the specified arguments to set.
107#
108# If the first argument is '-s' or '-u', we assume you want to call `shopt`
109# rather than `set` as there are some options only available via that.
110#
111# A common example is to disable shell globbing so that special meaning/care
112# may be used with variables/arguments to custom functions. That would be:
113# @CODE
114# eshopts_push -o noglob
115# for x in ${foo} ; do
116# if ...some check... ; then
117# eshopts_pop
85 return 0 118# return 0
119# fi
120# done
121# eshopts_pop
122# @CODE
123eshopts_push() {
124 # have to assume __ESHOPTS_SAVE__ isn't screwed with
125 # as a `declare -a` here will reset its value
126 local i=${#__ESHOPTS_SAVE__[@]}
127 if [[ $1 == -[su] ]] ; then
128 __ESHOPTS_SAVE__[$i]=$(shopt -p)
129 [[ $# -eq 0 ]] && return 0
130 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
131 else
132 __ESHOPTS_SAVE__[$i]=$-
133 [[ $# -eq 0 ]] && return 0
134 set "$@" || die "eshopts_push: bad options to set: $*"
135 fi
86} 136}
87 137
88# Default directory where patches are located 138# @FUNCTION: eshopts_pop
139# @USAGE:
140# @DESCRIPTION:
141# Restore the shell options to the state saved with the corresponding
142# eshopts_push call. See that function for more details.
143eshopts_pop() {
144 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
145 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
146 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
147 local s=${__ESHOPTS_SAVE__[$i]}
148 unset __ESHOPTS_SAVE__[$i]
149 if [[ ${s} == "shopt -"* ]] ; then
150 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
151 else
152 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
153 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
154 fi
155}
156
157# @VARIABLE: EPATCH_SOURCE
158# @DESCRIPTION:
159# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 160EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 161# @VARIABLE: EPATCH_SUFFIX
162# @DESCRIPTION:
163# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 164EPATCH_SUFFIX="patch.bz2"
165# @VARIABLE: EPATCH_OPTS
166# @DESCRIPTION:
92# Default options for patch 167# Default options for patch:
93EPATCH_OPTS="" 168# @CODE
169# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
170# --no-backup-if-mismatch - do not leave .orig files behind
171# -E - automatically remove empty files
172# @CODE
173EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
174# @VARIABLE: EPATCH_EXCLUDE
175# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 176# List of patches not to apply. Note this is only file names,
95# and not the full path .. 177# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 178EPATCH_EXCLUDE=""
179# @VARIABLE: EPATCH_SINGLE_MSG
180# @DESCRIPTION:
97# Change the printed message for a single patch. 181# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 182EPATCH_SINGLE_MSG=""
183# @VARIABLE: EPATCH_MULTI_MSG
184# @DESCRIPTION:
185# Change the printed message for multiple patches.
186EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
187# @VARIABLE: EPATCH_FORCE
188# @DESCRIPTION:
189# Only require patches to match EPATCH_SUFFIX rather than the extended
190# arch naming style.
191EPATCH_FORCE="no"
99 192
100# This function is for bulk patching, or in theory for just one 193# @FUNCTION: epatch
101# or two patches. 194# @USAGE: [patches] [dirs of patches]
195# @DESCRIPTION:
196# epatch is designed to greatly simplify the application of patches. It can
197# process patch files directly, or directories of patches. The patches may be
198# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
199# the -p option as epatch will automatically attempt -p0 to -p5 until things
200# apply successfully.
102# 201#
103# It should work with .bz2, .gz, .zip and plain text patches. 202# If you do not specify any options, then epatch will default to the directory
104# Currently all patches should be the same format. 203# specified by EPATCH_SOURCE.
105# 204#
106# You do not have to specify '-p' option to patch, as it will 205# When processing directories, epatch will apply all patches that match:
107# try with -p0 to -p5 until it succeed, or fail at -p5. 206# @CODE
108# 207# if ${EPATCH_FORCE} != "yes"
109# Above EPATCH_* variables can be used to control various defaults,
110# bug they should be left as is to ensure an ebuild can rely on
111# them for.
112#
113# Patches are applied in current directory.
114#
115# Bulk Patches should preferibly have the form of:
116#
117# ??_${ARCH}_foo.${EPATCH_SUFFIX} 208# ??_${ARCH}_foo.${EPATCH_SUFFIX}
209# else
210# *.${EPATCH_SUFFIX}
211# @CODE
212# The leading ?? are typically numbers used to force consistent patch ordering.
213# The arch field is used to apply patches only for the host architecture with
214# the special value of "all" means apply for everyone. Note that using values
215# other than "all" is highly discouraged -- you should apply patches all the
216# time and let architecture details be detected at configure/compile time.
118# 217#
119# For example: 218# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
219# for patches to apply.
120# 220#
121# 01_all_misc-fix.patch.bz2 221# Refer to the other EPATCH_xxx variables for more customization of behavior.
122# 02_sparc_another-fix.patch.bz2
123#
124# This ensures that there are a set order, and you can have ARCH
125# specific patches.
126#
127# If you however give an argument to epatch(), it will treat it as a
128# single patch that need to be applied if its a file. If on the other
129# hand its a directory, it will set EPATCH_SOURCE to this.
130#
131# <azarah@gentoo.org> (10 Nov 2002)
132#
133epatch() { 222epatch() {
134 local PIPE_CMD="" 223 _epatch_draw_line() {
135 local STDERR_TARGET="${T}/$$.out" 224 # create a line of same length as input string
136 local PATCH_TARGET="${T}/$$.patch" 225 [[ -z $1 ]] && set "$(printf "%65s" '')"
137 local PATCH_SUFFIX="" 226 echo "${1//?/=}"
227 }
228
229 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
230
231 # Let the rest of the code process one user arg at a time --
232 # each arg may expand into multiple patches, and each arg may
233 # need to start off with the default global EPATCH_xxx values
234 if [[ $# -gt 1 ]] ; then
235 local m
236 for m in "$@" ; do
237 epatch "${m}"
238 done
239 return 0
240 fi
241
138 local SINGLE_PATCH="no" 242 local SINGLE_PATCH="no"
139 local x="" 243 # no args means process ${EPATCH_SOURCE}
244 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
140 245
141 if [ "$#" -gt 1 ] 246 if [[ -f $1 ]] ; then
142 then
143 eerror "Invalid arguments to epatch()"
144 die "Invalid arguments to epatch()"
145 fi
146
147 if [ -n "$1" -a -f "$1" ]
148 then
149 SINGLE_PATCH="yes" 247 SINGLE_PATCH="yes"
150 248 set -- "$1"
151 local EPATCH_SOURCE="$1" 249 # Use the suffix from the single patch (localize it); the code
250 # below will find the suffix for us
152 local EPATCH_SUFFIX="${1##*\.}" 251 local EPATCH_SUFFIX=$1
153 252
154 elif [ -n "$1" -a -d "$1" ] 253 elif [[ -d $1 ]] ; then
155 then 254 # Some people like to make dirs of patches w/out suffixes (vim)
156 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 255 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
256
257 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
258 # Re-use EPATCH_SOURCE as a search dir
259 epatch "${EPATCH_SOURCE}/$1"
260 return $?
261
157 else 262 else
158 if [ ! -d ${EPATCH_SOURCE} ] 263 # sanity check ... if it isn't a dir or file, wtf man ?
264 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
265 echo
266 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
267 eerror
268 eerror " ${EPATCH_SOURCE}"
269 eerror " ( ${EPATCH_SOURCE##*/} )"
270 echo
271 die "Cannot find \$EPATCH_SOURCE!"
272 fi
273
274 local PIPE_CMD
275 case ${EPATCH_SUFFIX##*\.} in
276 xz) PIPE_CMD="xz -dc" ;;
277 lzma) PIPE_CMD="lzma -dc" ;;
278 bz2) PIPE_CMD="bzip2 -dc" ;;
279 gz|Z|z) PIPE_CMD="gzip -dc" ;;
280 ZIP|zip) PIPE_CMD="unzip -p" ;;
281 *) ;;
282 esac
283
284 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
285
286 local x
287 for x in "$@" ; do
288 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
289 # didn't match anything, ignore continue on
290 [[ ! -f ${x} ]] && continue
291
292 local patchname=${x##*/}
293
294 # Apply single patches, or forced sets of patches, or
295 # patches with ARCH dependant names.
296 # ???_arch_foo.patch
297 # Else, skip this input altogether
298 local a=${patchname#*_} # strip the ???_
299 a=${a%%_*} # strip the _foo.patch
300 if ! [[ ${SINGLE_PATCH} == "yes" || \
301 ${EPATCH_FORCE} == "yes" || \
302 ${a} == all || \
303 ${a} == ${ARCH} ]]
159 then 304 then
160 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 305 continue
161 then 306 fi
162 EPATCH_SOURCE="$1" 307
308 # Let people filter things dynamically
309 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
310 # let people use globs in the exclude
311 eshopts_push -o noglob
312
313 local ex
314 for ex in ${EPATCH_EXCLUDE} ; do
315 if [[ ${patchname} == ${ex} ]] ; then
316 eshopts_pop
317 continue 2
318 fi
319 done
320
321 eshopts_pop
322 fi
323
324 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
325 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
326 einfo "${EPATCH_SINGLE_MSG}"
327 else
328 einfo "Applying ${patchname} ..."
163 fi 329 fi
330 else
331 einfo " ${patchname} ..."
332 fi
164 333
334 # most of the time, there will only be one run per unique name,
335 # but if there are more, make sure we get unique log filenames
336 local STDERR_TARGET="${T}/${patchname}.out"
337 if [[ -e ${STDERR_TARGET} ]] ; then
338 STDERR_TARGET="${T}/${patchname}-$$.out"
339 fi
340
341 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
342
343 # Decompress the patch if need be
344 local count=0
345 local PATCH_TARGET
346 if [[ -n ${PIPE_CMD} ]] ; then
347 PATCH_TARGET="${T}/$$.patch"
348 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
349
350 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
351 echo
352 eerror "Could not extract patch!"
353 #die "Could not extract patch!"
354 count=5
355 break
356 fi
357 else
358 PATCH_TARGET=${x}
359 fi
360
361 # Check for absolute paths in patches. If sandbox is disabled,
362 # people could (accidently) patch files in the root filesystem.
363 # Or trigger other unpleasantries #237667. So disallow -p0 on
364 # such patches.
365 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
366 if [[ -n ${abs_paths} ]] ; then
367 count=1
368 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
369 fi
370 # Similar reason, but with relative paths.
371 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
372 if [[ -n ${rel_paths} ]] ; then
373 eqawarn "QA Notice: Your patch uses relative paths '../'."
374 eqawarn " In the future this will cause a failure."
375 eqawarn "${rel_paths}"
376 fi
377
378 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
379 while [[ ${count} -lt 5 ]] ; do
380 # Generate some useful debug info ...
381 (
382 _epatch_draw_line "***** ${patchname} *****"
165 echo 383 echo
166 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 384 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
385 echo
386 _epatch_draw_line "***** ${patchname} *****"
387 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
388 ret=$?
389 echo
390 echo "patch program exited with status ${ret}"
391 exit ${ret}
392 ) >> "${STDERR_TARGET}"
393
394 if [ $? -eq 0 ] ; then
395 (
396 _epatch_draw_line "***** ${patchname} *****"
397 echo
398 echo "ACTUALLY APPLYING ${patchname} ..."
399 echo
400 _epatch_draw_line "***** ${patchname} *****"
401 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
402 ret=$?
403 echo
404 echo "patch program exited with status ${ret}"
405 exit ${ret}
406 ) >> "${STDERR_TARGET}"
407
408 if [ $? -ne 0 ] ; then
409 echo
410 eerror "A dry-run of patch command succeeded, but actually"
411 eerror "applying the patch failed!"
412 #die "Real world sux compared to the dreamworld!"
413 count=5
414 fi
415 break
416 fi
417
418 : $(( count++ ))
419 done
420
421 # if we had to decompress the patch, delete the temp one
422 if [[ -n ${PIPE_CMD} ]] ; then
423 rm -f "${PATCH_TARGET}"
424 fi
425
426 if [[ ${count} -ge 5 ]] ; then
427 echo
428 eerror "Failed Patch: ${patchname} !"
429 eerror " ( ${PATCH_TARGET} )"
167 eerror 430 eerror
168 eerror " ${EPATCH_SOURCE}" 431 eerror "Include in your bugreport the contents of:"
432 eerror
433 eerror " ${STDERR_TARGET}"
169 echo 434 echo
170 die "Cannot find \$EPATCH_SOURCE!" 435 die "Failed Patch: ${patchname}!"
171 fi
172
173 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
174 fi 436 fi
175 437
176 case ${EPATCH_SUFFIX##*\.} in 438 # if everything worked, delete the patch log
177 bz2) 439 rm -f "${STDERR_TARGET}"
178 PIPE_CMD="bzip2 -dc" 440 eend 0
441 done
442
443 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
444 : # everything worked
445}
446
447# @FUNCTION: epatch_user
448# @USAGE:
449# @DESCRIPTION:
450# Applies user-provided patches to the source tree. The patches are
451# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
452# of these three directories to exist will be the one to use, ignoring
453# any more general directories which might exist as well.
454#
455# User patches are intended for quick testing of patches without ebuild
456# modifications, as well as for permanent customizations a user might
457# desire. Obviously, there can be no official support for arbitrarily
458# patched ebuilds. So whenever a build log in a bug report mentions that
459# user patches were applied, the user should be asked to reproduce the
460# problem without these.
461#
462# Not all ebuilds do call this function, so placing patches in the
463# stated directory might or might not work, depending on the package and
464# the eclasses it inherits and uses. It is safe to call the function
465# repeatedly, so it is always possible to add a call at the ebuild
466# level. The first call is the time when the patches will be
467# applied.
468#
469# Ideally, this function should be called after gentoo-specific patches
470# have been applied, so that their code can be modified as well, but
471# before calls to e.g. eautoreconf, as the user patches might affect
472# autotool input files as well.
473epatch_user() {
474 [[ $# -ne 0 ]] && die "epatch_user takes no options"
475
476 # Allow multiple calls to this function; ignore all but the first
477 local applied="${T}/epatch_user.applied"
478 [[ -e ${applied} ]] && return 2
479
480 # don't clobber any EPATCH vars that the parent might want
481 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
482 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
483 EPATCH_SOURCE=${base}/${CTARGET}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
485 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
486 if [[ -d ${EPATCH_SOURCE} ]] ; then
487 EPATCH_SOURCE=${EPATCH_SOURCE} \
179 PATCH_SUFFIX="bz2" 488 EPATCH_SUFFIX="patch" \
489 EPATCH_FORCE="yes" \
490 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
491 epatch
492 echo "${EPATCH_SOURCE}" > "${applied}"
493 return 0
494 fi
495 done
496 echo "none" > "${applied}"
497 return 1
498}
499
500# @FUNCTION: emktemp
501# @USAGE: [temp dir]
502# @DESCRIPTION:
503# Cheap replacement for when debianutils (and thus mktemp)
504# does not exist on the users system.
505emktemp() {
506 local exe="touch"
507 [[ $1 == -d ]] && exe="mkdir" && shift
508 local topdir=$1
509
510 if [[ -z ${topdir} ]] ; then
511 [[ -z ${T} ]] \
512 && topdir="/tmp" \
513 || topdir=${T}
514 fi
515
516 if ! type -P mktemp > /dev/null ; then
517 # system lacks `mktemp` so we have to fake it
518 local tmp=/
519 while [[ -e ${tmp} ]] ; do
520 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
521 done
522 ${exe} "${tmp}" || ${exe} -p "${tmp}"
523 echo "${tmp}"
524 else
525 # the args here will give slightly wierd names on BSD,
526 # but should produce a usable file on all userlands
527 if [[ ${exe} == "touch" ]] ; then
528 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
529 else
530 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
531 fi
532 fi
533}
534
535# @FUNCTION: edos2unix
536# @USAGE: <file> [more files ...]
537# @DESCRIPTION:
538# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
539# to remove all of these text utilities from DEPEND variables because this
540# is a script based solution. Just give it a list of files to convert and
541# they will all be changed from the DOS CRLF format to the UNIX LF format.
542edos2unix() {
543 [[ $# -eq 0 ]] && return 0
544 sed -i 's/\r$//' -- "$@" || die
545}
546
547# Make a desktop file !
548# Great for making those icons in kde/gnome startmenu !
549# Amaze your friends ! Get the women ! Join today !
550#
551# make_desktop_entry(<command>, [name], [icon], [type], [fields])
552#
553# binary: what command does the app run with ?
554# name: the name that will show up in the menu
555# icon: give your little like a pretty little icon ...
556# this can be relative (to /usr/share/pixmaps) or
557# a full path to an icon
558# type: what kind of application is this ? for categories:
559# http://standards.freedesktop.org/menu-spec/latest/apa.html
560# fields: extra fields to append to the desktop file; a printf string
561make_desktop_entry() {
562 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
563
564 local exec=${1}
565 local name=${2:-${PN}}
566 local icon=${3:-${PN}}
567 local type=${4}
568 local fields=${5}
569
570 if [[ -z ${type} ]] ; then
571 local catmaj=${CATEGORY%%-*}
572 local catmin=${CATEGORY##*-}
573 case ${catmaj} in
574 app)
575 case ${catmin} in
576 accessibility) type=Accessibility;;
577 admin) type=System;;
578 antivirus) type=System;;
579 arch) type=Archiving;;
580 backup) type=Archiving;;
581 cdr) type=DiscBurning;;
582 dicts) type=Dictionary;;
583 doc) type=Documentation;;
584 editors) type=TextEditor;;
585 emacs) type=TextEditor;;
586 emulation) type=Emulator;;
587 laptop) type=HardwareSettings;;
588 office) type=Office;;
589 pda) type=PDA;;
590 vim) type=TextEditor;;
591 xemacs) type=TextEditor;;
592 esac
593 ;;
594
595 dev)
596 type="Development"
597 ;;
598
599 games)
600 case ${catmin} in
601 action|fps) type=ActionGame;;
602 arcade) type=ArcadeGame;;
603 board) type=BoardGame;;
604 emulation) type=Emulator;;
605 kids) type=KidsGame;;
606 puzzle) type=LogicGame;;
607 roguelike) type=RolePlaying;;
608 rpg) type=RolePlaying;;
609 simulation) type=Simulation;;
610 sports) type=SportsGame;;
611 strategy) type=StrategyGame;;
612 esac
613 type="Game;${type}"
614 ;;
615
616 gnome)
617 type="Gnome;GTK"
618 ;;
619
620 kde)
621 type="KDE;Qt"
622 ;;
623
624 mail)
625 type="Network;Email"
626 ;;
627
628 media)
629 case ${catmin} in
630 gfx)
631 type=Graphics
632 ;;
633 *)
634 case ${catmin} in
635 radio) type=Tuner;;
636 sound) type=Audio;;
637 tv) type=TV;;
638 video) type=Video;;
639 esac
640 type="AudioVideo;${type}"
641 ;;
642 esac
643 ;;
644
645 net)
646 case ${catmin} in
647 dialup) type=Dialup;;
648 ftp) type=FileTransfer;;
649 im) type=InstantMessaging;;
650 irc) type=IRCClient;;
651 mail) type=Email;;
652 news) type=News;;
653 nntp) type=News;;
654 p2p) type=FileTransfer;;
655 voip) type=Telephony;;
656 esac
657 type="Network;${type}"
658 ;;
659
660 sci)
661 case ${catmin} in
662 astro*) type=Astronomy;;
663 bio*) type=Biology;;
664 calc*) type=Calculator;;
665 chem*) type=Chemistry;;
666 elec*) type=Electronics;;
667 geo*) type=Geology;;
668 math*) type=Math;;
669 physics) type=Physics;;
670 visual*) type=DataVisualization;;
671 esac
672 type="Education;Science;${type}"
673 ;;
674
675 sys)
676 type="System"
677 ;;
678
679 www)
680 case ${catmin} in
681 client) type=WebBrowser;;
682 esac
683 type="Network;${type}"
684 ;;
685
686 *)
687 type=
688 ;;
689 esac
690 fi
691 if [ "${SLOT}" == "0" ] ; then
692 local desktop_name="${PN}"
693 else
694 local desktop_name="${PN}-${SLOT}"
695 fi
696 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
697 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
698
699 # Don't append another ";" when a valid category value is provided.
700 type=${type%;}${type:+;}
701
702 eshopts_push -s extglob
703 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
704 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
705 ewarn "allowed in .desktop files if the value is not an absolute path."
706 icon=${icon%.@(xpm|png|svg)}
707 fi
708 eshopts_pop
709
710 cat <<-EOF > "${desktop}"
711 [Desktop Entry]
712 Name=${name}
713 Type=Application
714 Comment=${DESCRIPTION}
715 Exec=${exec}
716 TryExec=${exec%% *}
717 Icon=${icon}
718 Categories=${type}
719 EOF
720
721 if [[ ${fields:-=} != *=* ]] ; then
722 # 5th arg used to be value to Path=
723 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
724 fields="Path=${fields}"
725 fi
726 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
727
728 (
729 # wrap the env here so that the 'insinto' call
730 # doesn't corrupt the env of the caller
731 insinto /usr/share/applications
732 doins "${desktop}"
733 ) || die "installing desktop file failed"
734}
735
736# @FUNCTION: validate_desktop_entries
737# @USAGE: [directories]
738# @MAINTAINER:
739# Carsten Lohrke <carlo@gentoo.org>
740# @DESCRIPTION:
741# Validate desktop entries using desktop-file-utils
742validate_desktop_entries() {
743 if [[ -x /usr/bin/desktop-file-validate ]] ; then
744 einfo "Checking desktop entry validity"
745 local directories=""
746 for d in /usr/share/applications $@ ; do
747 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
748 done
749 if [[ -n ${directories} ]] ; then
750 for FILE in $(find ${directories} -name "*\.desktop" \
751 -not -path '*.hidden*' | sort -u 2>/dev/null)
752 do
753 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
754 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
755 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
756 done
757 fi
758 echo ""
759 else
760 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
761 fi
762}
763
764# @FUNCTION: make_session_desktop
765# @USAGE: <title> <command> [command args...]
766# @DESCRIPTION:
767# Make a GDM/KDM Session file. The title is the file to execute to start the
768# Window Manager. The command is the name of the Window Manager.
769#
770# You can set the name of the file via the ${wm} variable.
771make_session_desktop() {
772 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
773 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
774
775 local title=$1
776 local command=$2
777 local desktop=${T}/${wm:-${PN}}.desktop
778 shift 2
779
780 cat <<-EOF > "${desktop}"
781 [Desktop Entry]
782 Name=${title}
783 Comment=This session logs you into ${title}
784 Exec=${command} $*
785 TryExec=${command}
786 Type=XSession
787 EOF
788
789 (
790 # wrap the env here so that the 'insinto' call
791 # doesn't corrupt the env of the caller
792 insinto /usr/share/xsessions
793 doins "${desktop}"
794 )
795}
796
797# @FUNCTION: domenu
798# @USAGE: <menus>
799# @DESCRIPTION:
800# Install the list of .desktop menu files into the appropriate directory
801# (/usr/share/applications).
802domenu() {
803 (
804 # wrap the env here so that the 'insinto' call
805 # doesn't corrupt the env of the caller
806 local i j ret=0
807 insinto /usr/share/applications
808 for i in "$@" ; do
809 if [[ -f ${i} ]] ; then
810 doins "${i}"
811 ((ret+=$?))
812 elif [[ -d ${i} ]] ; then
813 for j in "${i}"/*.desktop ; do
814 doins "${j}"
815 ((ret+=$?))
816 done
817 else
818 ((++ret))
819 fi
820 done
821 exit ${ret}
822 )
823}
824
825# @FUNCTION: newmenu
826# @USAGE: <menu> <newname>
827# @DESCRIPTION:
828# Like all other new* functions, install the specified menu as newname.
829newmenu() {
830 (
831 # wrap the env here so that the 'insinto' call
832 # doesn't corrupt the env of the caller
833 insinto /usr/share/applications
834 newins "$@"
835 )
836}
837
838# @FUNCTION: doicon
839# @USAGE: <list of icons>
840# @DESCRIPTION:
841# Install the list of icons into the icon directory (/usr/share/pixmaps).
842# This is useful in conjunction with creating desktop/menu files.
843doicon() {
844 (
845 # wrap the env here so that the 'insinto' call
846 # doesn't corrupt the env of the caller
847 local i j ret
848 insinto /usr/share/pixmaps
849 for i in "$@" ; do
850 if [[ -f ${i} ]] ; then
851 doins "${i}"
852 ((ret+=$?))
853 elif [[ -d ${i} ]] ; then
854 for j in "${i}"/*.png ; do
855 doins "${j}"
856 ((ret+=$?))
857 done
858 else
859 ((++ret))
860 fi
861 done
862 exit ${ret}
863 )
864}
865
866# @FUNCTION: newicon
867# @USAGE: <icon> <newname>
868# @DESCRIPTION:
869# Like all other new* functions, install the specified icon as newname.
870newicon() {
871 (
872 # wrap the env here so that the 'insinto' call
873 # doesn't corrupt the env of the caller
874 insinto /usr/share/pixmaps
875 newins "$@"
876 )
877}
878
879# for internal use only (unpack_pdv and unpack_makeself)
880find_unpackable_file() {
881 local src=$1
882 if [[ -z ${src} ]] ; then
883 src=${DISTDIR}/${A}
884 else
885 if [[ -e ${DISTDIR}/${src} ]] ; then
886 src=${DISTDIR}/${src}
887 elif [[ -e ${PWD}/${src} ]] ; then
888 src=${PWD}/${src}
889 elif [[ -e ${src} ]] ; then
890 src=${src}
891 fi
892 fi
893 [[ ! -e ${src} ]] && return 1
894 echo "${src}"
895}
896
897# @FUNCTION: unpack_pdv
898# @USAGE: <file to unpack> <size of off_t>
899# @DESCRIPTION:
900# Unpack those pesky pdv generated files ...
901# They're self-unpacking programs with the binary package stuffed in
902# the middle of the archive. Valve seems to use it a lot ... too bad
903# it seems to like to segfault a lot :(. So lets take it apart ourselves.
904#
905# You have to specify the off_t size ... I have no idea how to extract that
906# information out of the binary executable myself. Basically you pass in
907# the size of the off_t type (in bytes) on the machine that built the pdv
908# archive.
909#
910# One way to determine this is by running the following commands:
911#
912# @CODE
913# strings <pdv archive> | grep lseek
914# strace -elseek <pdv archive>
915# @CODE
916#
917# Basically look for the first lseek command (we do the strings/grep because
918# sometimes the function call is _llseek or something) and steal the 2nd
919# parameter. Here is an example:
920#
921# @CODE
922# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
923# lseek
924# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
925# lseek(3, -4, SEEK_END) = 2981250
926# @CODE
927#
928# Thus we would pass in the value of '4' as the second parameter.
929unpack_pdv() {
930 local src=$(find_unpackable_file "$1")
931 local sizeoff_t=$2
932
933 [[ -z ${src} ]] && die "Could not locate source for '$1'"
934 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
935
936 local shrtsrc=$(basename "${src}")
937 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
938 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
939 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
940
941 # grab metadata for debug reasons
942 local metafile=$(emktemp)
943 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
944
945 # rip out the final file name from the metadata
946 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
947 datafile=$(basename "${datafile}")
948
949 # now lets uncompress/untar the file if need be
950 local tmpfile=$(emktemp)
951 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
952
953 local iscompressed=$(file -b "${tmpfile}")
954 if [[ ${iscompressed:0:8} == "compress" ]] ; then
955 iscompressed=1
956 mv ${tmpfile}{,.Z}
957 gunzip ${tmpfile}
958 else
959 iscompressed=0
960 fi
961 local istar=$(file -b "${tmpfile}")
962 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
963 istar=1
964 else
965 istar=0
966 fi
967
968 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
969 #dd if=${src} ibs=${metaskip} count=1 \
970 # | dd ibs=${tailskip} skip=1 \
971 # | gzip -dc \
972 # > ${datafile}
973 if [ ${iscompressed} -eq 1 ] ; then
974 if [ ${istar} -eq 1 ] ; then
975 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
976 | head -c $((${metaskip}-${tailskip})) \
977 | tar -xzf -
978 else
979 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
980 | head -c $((${metaskip}-${tailskip})) \
981 | gzip -dc \
982 > ${datafile}
983 fi
984 else
985 if [ ${istar} -eq 1 ] ; then
986 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
987 | head -c $((${metaskip}-${tailskip})) \
988 | tar --no-same-owner -xf -
989 else
990 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
991 | head -c $((${metaskip}-${tailskip})) \
992 > ${datafile}
993 fi
994 fi
995 true
996 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
997 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
998}
999
1000# @FUNCTION: unpack_makeself
1001# @USAGE: [file to unpack] [offset] [tail|dd]
1002# @DESCRIPTION:
1003# Unpack those pesky makeself generated files ...
1004# They're shell scripts with the binary package tagged onto
1005# the end of the archive. Loki utilized the format as does
1006# many other game companies.
1007#
1008# If the file is not specified, then ${A} is used. If the
1009# offset is not specified then we will attempt to extract
1010# the proper offset from the script itself.
1011unpack_makeself() {
1012 local src_input=${1:-${A}}
1013 local src=$(find_unpackable_file "${src_input}")
1014 local skip=$2
1015 local exe=$3
1016
1017 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1018
1019 local shrtsrc=$(basename "${src}")
1020 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1021 if [[ -z ${skip} ]] ; then
1022 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1023 local skip=0
1024 exe=tail
1025 case ${ver} in
1026 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1027 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1028 ;;
1029 2.0|2.0.1)
1030 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1031 ;;
1032 2.1.1)
1033 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1034 (( skip++ ))
1035 ;;
1036 2.1.2)
1037 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1038 (( skip++ ))
1039 ;;
1040 2.1.3)
1041 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1042 (( skip++ ))
1043 ;;
1044 2.1.4|2.1.5)
1045 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1046 skip=$(head -n ${skip} "${src}" | wc -c)
1047 exe="dd"
1048 ;;
1049 *)
1050 eerror "I'm sorry, but I was unable to support the Makeself file."
1051 eerror "The version I detected was '${ver}'."
1052 eerror "Please file a bug about the file ${shrtsrc} at"
1053 eerror "http://bugs.gentoo.org/ so that support can be added."
1054 die "makeself version '${ver}' not supported"
1055 ;;
1056 esac
1057 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1058 fi
1059 case ${exe} in
1060 tail) exe="tail -n +${skip} '${src}'";;
1061 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1062 *) die "makeself cant handle exe '${exe}'"
1063 esac
1064
1065 # lets grab the first few bytes of the file to figure out what kind of archive it is
1066 local filetype tmpfile=$(emktemp)
1067 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1068 filetype=$(file -b "${tmpfile}") || die
1069 case ${filetype} in
1070 *tar\ archive*)
1071 eval ${exe} | tar --no-same-owner -xf -
180 ;; 1072 ;;
181 gz|Z|z) 1073 bzip2*)
182 PIPE_CMD="gzip -dc" 1074 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
183 PATCH_SUFFIX="gz"
184 ;; 1075 ;;
185 ZIP|zip) 1076 gzip*)
186 PIPE_CMD="unzip -p" 1077 eval ${exe} | tar --no-same-owner -xzf -
187 PATCH_SUFFIX="zip" 1078 ;;
1079 compress*)
1080 eval ${exe} | gunzip | tar --no-same-owner -xf -
188 ;; 1081 ;;
189 *) 1082 *)
190 PIPE_CMD="cat" 1083 eerror "Unknown filetype \"${filetype}\" ?"
191 PATCH_SUFFIX="patch" 1084 false
192 ;; 1085 ;;
193 esac 1086 esac
1087 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1088}
194 1089
195 if [ "${SINGLE_PATCH}" = "no" ] 1090# @FUNCTION: check_license
196 then 1091# @USAGE: [license]
197 einfo "Applying various patches (bugfixes/updates)..." 1092# @DESCRIPTION:
1093# Display a license for user to accept. If no license is
1094# specified, then ${LICENSE} is used.
1095check_license() {
1096 local lic=$1
1097 if [ -z "${lic}" ] ; then
1098 lic="${PORTDIR}/licenses/${LICENSE}"
1099 else
1100 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1101 lic="${PORTDIR}/licenses/${lic}"
1102 elif [ -e "${PWD}/${lic}" ] ; then
1103 lic="${PWD}/${lic}"
1104 elif [ -e "${lic}" ] ; then
1105 lic="${lic}"
198 fi 1106 fi
199 for x in ${EPATCH_SOURCE} 1107 fi
1108 local l="`basename ${lic}`"
1109
1110 # here is where we check for the licenses the user already
1111 # accepted ... if we don't find a match, we make the user accept
1112 local alic
1113 eshopts_push -o noglob # so that bash doesn't expand "*"
1114 for alic in ${ACCEPT_LICENSE} ; do
1115 if [[ ${alic} == ${l} ]]; then
1116 eshopts_pop
1117 return 0
1118 fi
200 do 1119 done
201 # New ARCH dependant patch naming scheme... 1120 eshopts_pop
202 # 1121 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
203 # ???_arch_foo.patch 1122
204 # 1123 local licmsg=$(emktemp)
205 if [ -f ${x} ] && \ 1124 cat <<-EOF > ${licmsg}
206 [ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] 1125 **********************************************************
207 then 1126 The following license outlines the terms of use of this
1127 package. You MUST accept this license for installation to
1128 continue. When you are done viewing, hit 'q'. If you
1129 CTRL+C out of this, the install will not run!
1130 **********************************************************
1131
1132 EOF
1133 cat ${lic} >> ${licmsg}
1134 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1135 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1136 read alic
1137 case ${alic} in
1138 yes|Yes|y|Y)
1139 return 0
1140 ;;
1141 *)
1142 echo;echo;echo
1143 eerror "You MUST accept the license to continue! Exiting!"
1144 die "Failed to accept license"
1145 ;;
1146 esac
1147}
1148
1149# @FUNCTION: cdrom_get_cds
1150# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1151# @DESCRIPTION:
1152# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1153# the whole 'non-interactive' policy, but damnit I want CD support !
1154#
1155# With these cdrom functions we handle all the user interaction and
1156# standardize everything. All you have to do is call cdrom_get_cds()
1157# and when the function returns, you can assume that the cd has been
1158# found at CDROM_ROOT.
1159#
1160# The function will attempt to locate a cd based upon a file that is on
1161# the cd. The more files you give this function, the more cds
1162# the cdrom functions will handle.
1163#
1164# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1165# etc... If you want to give the cds better names, then just export
1166# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1167# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1168# also use the CDROM_NAME_SET bash array.
1169#
1170# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1171cdrom_get_cds() {
1172 # first we figure out how many cds we're dealing with by
1173 # the # of files they gave us
208 local count=0 1174 local cdcnt=0
209 local popts="${EPATCH_OPTS}" 1175 local f=
1176 for f in "$@" ; do
1177 ((++cdcnt))
1178 export CDROM_CHECK_${cdcnt}="$f"
1179 done
1180 export CDROM_TOTAL_CDS=${cdcnt}
1181 export CDROM_CURRENT_CD=1
210 1182
211 if [ -n "${EPATCH_EXCLUDE}" ] 1183 # now we see if the user gave use CD_ROOT ...
212 then 1184 # if they did, let's just believe them that it's correct
213 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ] 1185 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
214 then 1186 local var=
1187 cdcnt=0
1188 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1189 ((++cdcnt))
1190 var="CD_ROOT_${cdcnt}"
1191 [[ -z ${!var} ]] && var="CD_ROOT"
1192 if [[ -z ${!var} ]] ; then
1193 eerror "You must either use just the CD_ROOT"
1194 eerror "or specify ALL the CD_ROOT_X variables."
1195 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1196 die "could not locate CD_ROOT_${cdcnt}"
1197 fi
1198 done
1199 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1200 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1201 export CDROM_SET=-1
1202 for f in ${CDROM_CHECK_1//:/ } ; do
1203 ((++CDROM_SET))
1204 [[ -e ${CDROM_ROOT}/${f} ]] && break
1205 done
1206 export CDROM_MATCH=${f}
1207 return
1208 fi
1209
1210 # User didn't help us out so lets make sure they know they can
1211 # simplify the whole process ...
1212 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1213 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1214 echo
1215 einfo "If you do not have the CD, but have the data files"
1216 einfo "mounted somewhere on your filesystem, just export"
1217 einfo "the variable CD_ROOT so that it points to the"
1218 einfo "directory containing the files."
1219 echo
1220 einfo "For example:"
1221 einfo "export CD_ROOT=/mnt/cdrom"
1222 echo
1223 else
1224 if [[ -n ${CDROM_NAME_SET} ]] ; then
1225 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1226 cdcnt=0
1227 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1228 ((++cdcnt))
1229 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1230 done
1231 fi
1232
1233 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1234 cdcnt=0
1235 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1236 ((++cdcnt))
1237 var="CDROM_NAME_${cdcnt}"
1238 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1239 done
1240 echo
1241 einfo "If you do not have the CDs, but have the data files"
1242 einfo "mounted somewhere on your filesystem, just export"
1243 einfo "the following variables so they point to the right place:"
1244 einfon ""
1245 cdcnt=0
1246 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1247 ((++cdcnt))
1248 echo -n " CD_ROOT_${cdcnt}"
1249 done
1250 echo
1251 einfo "Or, if you have all the files in the same place, or"
1252 einfo "you only have one cdrom, you can export CD_ROOT"
1253 einfo "and that place will be used as the same data source"
1254 einfo "for all the CDs."
1255 echo
1256 einfo "For example:"
1257 einfo "export CD_ROOT_1=/mnt/cdrom"
1258 echo
1259 fi
1260
1261 export CDROM_SET=""
1262 export CDROM_CURRENT_CD=0
1263 cdrom_load_next_cd
1264}
1265
1266# @FUNCTION: cdrom_load_next_cd
1267# @DESCRIPTION:
1268# Some packages are so big they come on multiple CDs. When you're done reading
1269# files off a CD and want access to the next one, just call this function.
1270# Again, all the messy details of user interaction are taken care of for you.
1271# Once this returns, just read the variable CDROM_ROOT for the location of the
1272# mounted CD. Note that you can only go forward in the CD list, so make sure
1273# you only call this function when you're done using the current CD.
1274cdrom_load_next_cd() {
1275 local var
1276 ((++CDROM_CURRENT_CD))
1277
1278 unset CDROM_ROOT
1279 var=CD_ROOT_${CDROM_CURRENT_CD}
1280 [[ -z ${!var} ]] && var="CD_ROOT"
1281 if [[ -z ${!var} ]] ; then
1282 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1283 _cdrom_locate_file_on_cd ${!var}
1284 else
1285 export CDROM_ROOT=${!var}
1286 fi
1287
1288 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1289}
1290
1291# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1292# functions. this should *never* be called from an ebuild.
1293# all it does is try to locate a give file on a cd ... if the cd isn't
1294# found, then a message asking for the user to insert the cdrom will be
1295# displayed and we'll hang out here until:
1296# (1) the file is found on a mounted cdrom
1297# (2) the user hits CTRL+C
1298_cdrom_locate_file_on_cd() {
1299 local mline=""
1300 local showedmsg=0 showjolietmsg=0
1301
1302 while [[ -z ${CDROM_ROOT} ]] ; do
1303 local i=0
1304 local -a cdset=(${*//:/ })
1305 if [[ -n ${CDROM_SET} ]] ; then
1306 cdset=(${cdset[${CDROM_SET}]})
1307 fi
1308
1309 while [[ -n ${cdset[${i}]} ]] ; do
1310 local dir=$(dirname ${cdset[${i}]})
1311 local file=$(basename ${cdset[${i}]})
1312
1313 local point= node= fs= foo=
1314 while read point node fs foo ; do
1315 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1316 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
215 continue 1317 && continue
1318 point=${point//\040/ }
1319 [[ ! -d ${point}/${dir} ]] && continue
1320 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1321 export CDROM_ROOT=${point}
1322 export CDROM_SET=${i}
1323 export CDROM_MATCH=${cdset[${i}]}
1324 return
1325 done <<< "$(get_mounts)"
1326
1327 ((++i))
1328 done
1329
1330 echo
1331 if [[ ${showedmsg} -eq 0 ]] ; then
1332 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1333 if [[ -z ${CDROM_NAME} ]] ; then
1334 einfo "Please insert+mount the cdrom for ${PN} now !"
1335 else
1336 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1337 fi
1338 else
1339 if [[ -z ${CDROM_NAME_1} ]] ; then
1340 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1341 else
1342 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1343 einfo "Please insert+mount the ${!var} cdrom now !"
216 fi 1344 fi
217 fi 1345 fi
1346 showedmsg=1
1347 fi
1348 einfo "Press return to scan for the cd again"
1349 einfo "or hit CTRL+C to abort the emerge."
1350 echo
1351 if [[ ${showjolietmsg} -eq 0 ]] ; then
1352 showjolietmsg=1
1353 else
1354 ewarn "If you are having trouble with the detection"
1355 ewarn "of your CD, it is possible that you do not have"
1356 ewarn "Joliet support enabled in your kernel. Please"
1357 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1358 ebeep 5
1359 fi
1360 read || die "something is screwed with your system"
1361 done
1362}
1363
1364# @FUNCTION: strip-linguas
1365# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1366# @DESCRIPTION:
1367# Make sure that LINGUAS only contains languages that
1368# a package can support. The first form allows you to
1369# specify a list of LINGUAS. The -i builds a list of po
1370# files found in all the directories and uses the
1371# intersection of the lists. The -u builds a list of po
1372# files found in all the directories and uses the union
1373# of the lists.
1374strip-linguas() {
1375 local ls newls nols
1376 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1377 local op=$1; shift
1378 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1379 local d f
1380 for d in "$@" ; do
1381 if [[ ${op} == "-u" ]] ; then
1382 newls=${ls}
1383 else
1384 newls=""
218 1385 fi
219 if [ "${SINGLE_PATCH}" = "yes" ] 1386 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
220 then 1387 if [[ ${op} == "-i" ]] ; then
221 if [ -n "${EPATCH_SINGLE_MSG}" ] 1388 has ${f} ${ls} && newls="${newls} ${f}"
222 then
223 einfo "${EPATCH_SINGLE_MSG}"
224 else 1389 else
225 einfo "Applying ${x##*/}..." 1390 has ${f} ${ls} || newls="${newls} ${f}"
226 fi 1391 fi
227 else
228 einfo " ${x##*/}..."
229 fi
230
231 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
232 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
233
234 # Allow for prefix to differ ... im lazy, so shoot me :/
235 while [ "${count}" -lt 5 ]
236 do
237 # Generate some useful debug info ...
238 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
239 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
240
241 if [ "${PATCH_SUFFIX}" != "patch" ]
242 then
243 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
244 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245 else
246 PATCH_TARGET="${x}"
247 fi
248
249 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
250 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
251
252 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
253 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
254
255 if [ "${PATCH_SUFFIX}" != "patch" ]
256 then
257 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
258 then
259 echo
260 eerror "Could not extract patch!"
261 #die "Could not extract patch!"
262 count=5
263 break
264 fi
265 fi
266
267 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
268 then
269 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
270 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
271 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
272 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
273 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
274
275 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
276
277 if [ "$?" -ne 0 ]
278 then
279 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
280 echo
281 eerror "A dry-run of patch command succeeded, but actually"
282 eerror "applying the patch failed!"
283 #die "Real world sux compared to the dreamworld!"
284 count=5
285 fi
286
287 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
288
289 break
290 fi
291
292 count=$((count + 1))
293 done 1392 done
294 1393 ls=${newls}
295 if [ "${PATCH_SUFFIX}" != "patch" ] 1394 done
296 then 1395 else
297 rm -f ${PATCH_TARGET} 1396 ls="$@"
298 fi 1397 fi
299 1398
300 if [ "${count}" -eq 5 ] 1399 nols=""
301 then 1400 newls=""
302 echo 1401 for f in ${LINGUAS} ; do
303 eerror "Failed Patch: ${x##*/}!" 1402 if has ${f} ${ls} ; then
304 eerror 1403 newls="${newls} ${f}"
305 eerror "Include in your bugreport the contents of:" 1404 else
306 eerror 1405 nols="${nols} ${f}"
307 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
308 echo
309 die "Failed Patch: ${x##*/}!"
310 fi
311
312 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
313
314 eend 0
315 fi 1406 fi
316 done 1407 done
317 if [ "${SINGLE_PATCH}" = "no" ] 1408 [[ -n ${nols} ]] \
318 then 1409 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
319 einfo "Done with patching" 1410 export LINGUAS=${newls:1}
320 fi
321} 1411}
322 1412
323# This function check how many cpu's are present, and then set 1413# @FUNCTION: preserve_old_lib
324# -j in MAKEOPTS accordingly. 1414# @USAGE: <libs to preserve> [more libs]
325# 1415# @DESCRIPTION:
326# Thanks to nall <nall@gentoo.org> for this. 1416# These functions are useful when a lib in your package changes ABI SONAME.
327# 1417# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
328get_number_of_jobs() { 1418# would break packages that link against it. Most people get around this
329 local jobs=0 1419# by using the portage SLOT mechanism, but that is not always a relevant
330 1420# solution, so instead you can call this from pkg_preinst. See also the
331 if [ ! -r /proc/cpuinfo ] 1421# preserve_old_lib_notify function.
332 then 1422preserve_old_lib() {
333 return 1 1423 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
334 fi 1424 eerror "preserve_old_lib() must be called from pkg_preinst() only"
335 1425 die "Invalid preserve_old_lib() usage"
336 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
337 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
338 then
339 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
340 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
341 ADMINPARAM="${ADMINPARAM/-j}"
342 fi
343
344 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
345
346 if [ "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
347 "${ARCH}" = "arm" -o "${ARCH}" = "mips" ]
348 then
349 # these archs will always have "[Pp]rocessor"
350 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
351
352 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
353 then
354 # sparc always has "ncpus active"
355 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
356
357 elif [ "${ARCH}" = "alpha" ]
358 then
359 # alpha has "cpus active", but only when compiled with SMP
360 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
361 then
362 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
363 else
364 jobs=2
365 fi 1426 fi
366 1427 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
367 elif [ "${ARCH}" = "ppc" ] 1428
368 then 1429 # let portage worry about it
369 # ppc has "processor", but only when compiled with SMP 1430 has preserve-libs ${FEATURES} && return 0
370 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ] 1431
371 then 1432 local lib dir
372 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))" 1433 for lib in "$@" ; do
373 else 1434 [[ -e ${ROOT}/${lib} ]] || continue
374 jobs=2 1435 dir=${lib%/*}
1436 dodir ${dir} || die "dodir ${dir} failed"
1437 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1438 touch "${D}"/${lib}
1439 done
1440}
1441
1442# @FUNCTION: preserve_old_lib_notify
1443# @USAGE: <libs to notify> [more libs]
1444# @DESCRIPTION:
1445# Spit helpful messages about the libraries preserved by preserve_old_lib.
1446preserve_old_lib_notify() {
1447 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1448 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1449 die "Invalid preserve_old_lib_notify() usage"
375 fi 1450 fi
376 else 1451
377 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))" 1452 # let portage worry about it
378 die "Unknown ARCH -- ${ARCH}!" 1453 has preserve-libs ${FEATURES} && return 0
1454
1455 local lib notice=0
1456 for lib in "$@" ; do
1457 [[ -e ${ROOT}/${lib} ]] || continue
1458 if [[ ${notice} -eq 0 ]] ; then
1459 notice=1
1460 ewarn "Old versions of installed libraries were detected on your system."
1461 ewarn "In order to avoid breaking packages that depend on these old libs,"
1462 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1463 ewarn "in order to remove these old dependencies. If you do not have this"
1464 ewarn "helper program, simply emerge the 'gentoolkit' package."
1465 ewarn
379 fi 1466 fi
380 1467 # temp hack for #348634 #357225
381 # Make sure the number is valid ... 1468 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
382 if [ "${jobs}" -lt 1 ] 1469 ewarn " # revdep-rebuild --library '${lib}'"
383 then 1470 done
384 jobs=1 1471 if [[ ${notice} -eq 1 ]] ; then
385 fi 1472 ewarn
386 1473 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
387 if [ -n "${ADMINPARAM}" ] 1474 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
388 then 1475 for lib in "$@" ; do
389 if [ "${jobs}" -gt "${ADMINPARAM}" ] 1476 ewarn " # rm '${lib}'"
390 then 1477 done
391 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
392 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
393 else
394 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
395 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
396 fi 1478 fi
397 fi
398} 1479}
399 1480
400# Simplify/standardize adding users to the system 1481# @FUNCTION: built_with_use
401# vapier@gentoo.org 1482# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1483# @DESCRIPTION:
402# 1484#
403# enewuser(username, uid, shell, homedir, groups, extra options) 1485# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
404# 1486#
405# Default values if you do not specify any: 1487# A temporary hack until portage properly supports DEPENDing on USE
406# username: REQUIRED ! 1488# flags being enabled in packages. This will check to see if the specified
407# uid: next available (see useradd(8)) 1489# DEPEND atom was built with the specified list of USE flags. The
408# shell: /bin/false 1490# --missing option controls the behavior if called on a package that does
409# homedir: /dev/null 1491# not actually support the defined USE flags (aka listed in IUSE).
410# groups: none 1492# The default is to abort (call die). The -a and -o flags control
411# extra: comment of 'added by portage for ${PN}' 1493# the requirements of the USE flags. They correspond to "and" and "or"
412enewuser() { 1494# logic. So the -a flag means all listed USE flags must be enabled
413 # get the username 1495# while the -o flag means at least one of the listed IUSE flags must be
414 local euser="$1"; shift 1496# enabled. The --hidden option is really for internal use only as it
415 if [ -z "${euser}" ] ; then 1497# means the USE flag we're checking is hidden expanded, so it won't be found
416 eerror "No username specified !" 1498# in IUSE like normal USE flags.
417 die "Cannot call enewuser without a username" 1499#
418 fi 1500# Remember that this function isn't terribly intelligent so order of optional
419 einfo "Adding user '${euser}' to your system ..." 1501# flags matter.
420 1502built_with_use() {
421 # setup a file for testing usernames/groups 1503 local hidden="no"
422 local tmpfile="`mktemp -p ${T}`" 1504 if [[ $1 == "--hidden" ]] ; then
423 touch ${tmpfile} 1505 hidden="yes"
424 chown ${euser} ${tmpfile} >& /dev/null 1506 shift
425 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
426
427 # see if user already exists
428 if [ "${euser}" == "${realuser}" ] ; then
429 einfo "${euser} already exists on your system :)"
430 return 0
431 fi
432
433 # options to pass to useradd
434 local opts=""
435
436 # handle uid
437 local euid="$1"; shift
438 if [ ! -z "${euid}" ] ; then
439 if [ ${euid} -gt 0 ] ; then
440 opts="${opts} -u ${euid}"
441 else
442 eerror "Userid given but is not greater than 0 !"
443 die "${euid} is not a valid UID"
444 fi 1507 fi
445 else
446 euid="next available"
447 fi
448 einfo " - Userid: ${euid}"
449 1508
450 # handle shell 1509 local missing_action="die"
451 local eshell="$1"; shift 1510 if [[ $1 == "--missing" ]] ; then
452 if [ ! -z "${eshell}" ] ; then 1511 missing_action=$2
453 if [ ! -e ${eshell} ] ; then 1512 shift ; shift
454 eerror "A shell was specified but it does not exist !" 1513 case ${missing_action} in
455 die "${eshell} does not exist" 1514 true|false|die) ;;
1515 *) die "unknown action '${missing_action}'";;
1516 esac
456 fi 1517 fi
457 else
458 eshell=/bin/false
459 fi
460 einfo " - Shell: ${eshell}"
461 opts="${opts} -s ${eshell}"
462 1518
463 # handle homedir 1519 local opt=$1
464 local ehome="$1"; shift 1520 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
465 if [ -z "${ehome}" ] ; then
466 ehome=/dev/null
467 fi
468 einfo " - Home: ${ehome}"
469 opts="${opts} -d ${ehome}"
470 1521
471 # handle groups 1522 local PKG=$(best_version $1)
472 local egroups="$1"; shift 1523 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
473 if [ ! -z "${egroups}" ] ; then 1524 shift
474 local realgroup 1525
475 local oldifs="${IFS}" 1526 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
476 export IFS="," 1527 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
477 for g in ${egroups} ; do 1528
478 chgrp ${g} ${tmpfile} >& /dev/null 1529 # if the IUSE file doesn't exist, the read will error out, we need to handle
479 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`" 1530 # this gracefully
480 if [ "${g}" != "${realgroup}" ] ; then 1531 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
481 eerror "You must add ${g} to the system first" 1532 case ${missing_action} in
482 die "${g} is not a valid GID" 1533 true) return 0;;
1534 false) return 1;;
1535 die) die "Unable to determine what USE flags $PKG was built with";;
1536 esac
1537 fi
1538
1539 if [[ ${hidden} == "no" ]] ; then
1540 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1541 # Don't check USE_EXPAND #147237
1542 local expand
1543 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1544 if [[ $1 == ${expand}_* ]] ; then
1545 expand=""
1546 break
483 fi 1547 fi
484 done 1548 done
485 export IFS="${oldifs}" 1549 if [[ -n ${expand} ]] ; then
486 opts="${opts} -g ${egroups}" 1550 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1551 case ${missing_action} in
1552 true) return 0;;
1553 false) return 1;;
1554 die) die "$PKG does not actually support the $1 USE flag!";;
1555 esac
1556 fi
1557 fi
1558 fi
1559
1560 local USE_BUILT=$(<${USEFILE})
1561 while [[ $# -gt 0 ]] ; do
1562 if [[ ${opt} = "-o" ]] ; then
1563 has $1 ${USE_BUILT} && return 0
1564 else
1565 has $1 ${USE_BUILT} || return 1
1566 fi
1567 shift
1568 done
1569 [[ ${opt} = "-a" ]]
1570}
1571
1572# @FUNCTION: epunt_cxx
1573# @USAGE: [dir to scan]
1574# @DESCRIPTION:
1575# Many configure scripts wrongly bail when a C++ compiler could not be
1576# detected. If dir is not specified, then it defaults to ${S}.
1577#
1578# http://bugs.gentoo.org/73450
1579epunt_cxx() {
1580 local dir=$1
1581 [[ -z ${dir} ]] && dir=${S}
1582 ebegin "Removing useless C++ checks"
1583 local f
1584 find "${dir}" -name configure | while read f ; do
1585 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1586 done
1587 eend 0
1588}
1589
1590# @FUNCTION: make_wrapper
1591# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1592# @DESCRIPTION:
1593# Create a shell wrapper script named wrapper in installpath
1594# (defaults to the bindir) to execute target (default of wrapper) by
1595# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1596# libpaths followed by optionally changing directory to chdir.
1597make_wrapper() {
1598 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1599 local tmpwrapper=$(emktemp)
1600 # We don't want to quote ${bin} so that people can pass complex
1601 # things as $bin ... "./someprog --args"
1602 cat << EOF > "${tmpwrapper}"
1603#!/bin/sh
1604cd "${chdir:-.}"
1605if [ -n "${libdir}" ] ; then
1606 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1607 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
487 else 1608 else
488 egroups="(none)" 1609 export LD_LIBRARY_PATH="${libdir}"
1610 fi
489 fi 1611fi
490 einfo " - Groups: ${egroups}" 1612exec ${bin} "\$@"
491 1613EOF
492 # handle extra and add the user 1614 chmod go+rx "${tmpwrapper}"
493 local eextra="$@" 1615 if [[ -n ${path} ]] ; then
494 local oldsandbox="${oldsandbox}" 1616 (
495 export SANDBOX_ON="0" 1617 exeinto "${path}"
496 if [ -z "${eextra}" ] ; then 1618 newexe "${tmpwrapper}" "${wrapper}"
497 useradd ${opts} ${euser} \ 1619 ) || die
498 -c "added by portage for ${PN}" \
499 || die "enewuser failed"
500 else 1620 else
501 einfo " - Extra: ${eextra}" 1621 newbin "${tmpwrapper}" "${wrapper}" || die
502 useradd ${opts} ${euser} ${eextra} \
503 || die "enewuser failed"
504 fi
505 export SANDBOX_ON="${oldsandbox}"
506
507 if [ ! -e ${ehome} ] && [ ! -e ${D}/${ehome} ] ; then
508 einfo " - Creating ${ehome} in ${D}"
509 dodir ${ehome}
510 fperms ${euser} ${ehome}
511 fi
512}
513
514# Simplify/standardize adding groups to the system
515# vapier@gentoo.org
516#
517# enewgroup(group, gid)
518#
519# Default values if you do not specify any:
520# groupname: REQUIRED !
521# gid: next available (see groupadd(8))
522# extra: none
523enewgroup() {
524 # get the group
525 local egroup="$1"; shift
526 if [ -z "${egroup}" ] ; then
527 eerror "No group specified !"
528 die "Cannot call enewgroup without a group"
529 fi
530 einfo "Adding group '${egroup}' to your system ..."
531
532 # setup a file for testing groupname
533 local tmpfile="`mktemp -p ${T}`"
534 touch ${tmpfile}
535 chgrp ${egroup} ${tmpfile} >& /dev/null
536 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
537
538 # see if group already exists
539 if [ "${egroup}" == "${realgroup}" ] ; then
540 einfo "${egroup} already exists on your system :)"
541 return 0
542 fi
543
544 # options to pass to useradd
545 local opts=""
546
547 # handle gid
548 local egid="$1"; shift
549 if [ ! -z "${egid}" ] ; then
550 if [ ${egid} -gt 0 ] ; then
551 opts="${opts} -g ${egid}"
552 else
553 eerror "Groupid given but is not greater than 0 !"
554 die "${egid} is not a valid GID"
555 fi 1622 fi
556 else
557 egid="next available"
558 fi
559 einfo " - Groupid: ${egid}"
560
561 # handle extra
562 local eextra="$@"
563 opts="${opts} ${eextra}"
564
565 # add the group
566 local oldsandbox="${oldsandbox}"
567 export SANDBOX_ON="0"
568 groupadd ${opts} ${egroup} || die "enewgroup failed"
569 export SANDBOX_ON="${oldsandbox}"
570} 1623}
1624
1625# @FUNCTION: path_exists
1626# @USAGE: [-a|-o] <paths>
1627# @DESCRIPTION:
1628# Check if the specified paths exist. Works for all types of paths
1629# (files/dirs/etc...). The -a and -o flags control the requirements
1630# of the paths. They correspond to "and" and "or" logic. So the -a
1631# flag means all the paths must exist while the -o flag means at least
1632# one of the paths must exist. The default behavior is "and". If no
1633# paths are specified, then the return value is "false".
1634path_exists() {
1635 local opt=$1
1636 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1637
1638 # no paths -> return false
1639 # same behavior as: [[ -e "" ]]
1640 [[ $# -eq 0 ]] && return 1
1641
1642 local p r=0
1643 for p in "$@" ; do
1644 [[ -e ${p} ]]
1645 : $(( r += $? ))
1646 done
1647
1648 case ${opt} in
1649 -a) return $(( r != 0 )) ;;
1650 -o) return $(( r == $# )) ;;
1651 esac
1652}
1653
1654# @FUNCTION: in_iuse
1655# @USAGE: <flag>
1656# @DESCRIPTION:
1657# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1658# as necessary.
1659#
1660# Note that this function should not be used in the global scope.
1661in_iuse() {
1662 debug-print-function ${FUNCNAME} "${@}"
1663 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1664
1665 local flag=${1}
1666 local liuse=( ${IUSE} )
1667
1668 has "${flag}" "${liuse[@]#[+-]}"
1669}
1670
1671# @FUNCTION: use_if_iuse
1672# @USAGE: <flag>
1673# @DESCRIPTION:
1674# Return true if the given flag is in USE and IUSE.
1675#
1676# Note that this function should not be used in the global scope.
1677use_if_iuse() {
1678 in_iuse $1 || return 1
1679 use $1
1680}
1681
1682# @FUNCTION: usex
1683# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1684# @DESCRIPTION:
1685# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1686# otherwise echo [false output][false suffix] (defaults to "no").
1687usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.370

  ViewVC Help
Powered by ViewVC 1.1.20